package org.dromara.work.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.work.domain.bo.TpBlockBo;
import org.dromara.work.domain.vo.TpBlockVo;
import org.dromara.work.domain.TpBlock;
import org.dromara.work.mapper.TpBlockMapper;
import org.dromara.work.service.ITpBlockService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 屏蔽拉黑Service业务层处理
 *
 * @author Maosw
 * @date 2025-04-12
 */
@RequiredArgsConstructor
@Service
public class TpBlockServiceImpl implements ITpBlockService {

    private final TpBlockMapper baseMapper;

    /**
     * 查询屏蔽拉黑
     *
     * @param id 主键
     * @return 屏蔽拉黑
     */
    @Override
    public TpBlockVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询屏蔽拉黑列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 屏蔽拉黑分页列表
     */
    @Override
    public TableDataInfo<TpBlockVo> queryPageList(TpBlockBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpBlock> lqw = buildQueryWrapper(bo);
        Page<TpBlockVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的屏蔽拉黑列表
     *
     * @param bo 查询条件
     * @return 屏蔽拉黑列表
     */
    @Override
    public List<TpBlockVo> queryList(TpBlockBo bo) {
        LambdaQueryWrapper<TpBlock> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpBlock> buildQueryWrapper(TpBlockBo bo) {
        LambdaQueryWrapper<TpBlock> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TpBlock::getId);
        lqw.eq(bo.getUserId() != null, TpBlock::getUserId, bo.getUserId());
        lqw.eq(bo.getToUserId() != null, TpBlock::getToUserId, bo.getToUserId());
        lqw.eq(bo.getType() != null, TpBlock::getType, bo.getType());
        return lqw;
    }

    /**
     * 新增屏蔽拉黑
     *
     * @param bo 屏蔽拉黑
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpBlockBo bo) {
        TpBlock add = MapstructUtils.convert(bo, TpBlock.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改屏蔽拉黑
     *
     * @param bo 屏蔽拉黑
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpBlockBo bo) {
        TpBlock update = MapstructUtils.convert(bo, TpBlock.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpBlock entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除屏蔽拉黑信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
